//////////////////////////////////////////////////////////////////////////
// MMs BLACK EAGLE 							//
//////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <mem.h>
#include <dos.h>

//////////////////////////////////////////////////////////////////////////
// Definitionen und Globales		 				//
//////////////////////////////////////////////////////////////////////////
// Speicher der bentigt wird
#define need_mem_sound 377000
#define need_mem_no_sound 224000
// Zeiger
unsigned char *text_ptr;
unsigned char *pixel_ptr;
unsigned char *dma_buffer_ptr;
unsigned char *be_ptr;
unsigned char *be_missel_ptr;
unsigned char *be_missel2_ptr;
unsigned char *enemy_missel_ptr;
unsigned char *enemy_ptr;
unsigned char *haus_ptr;
unsigned char *exp_ptr;
unsigned char *plasma_ptr;
unsigned char *hud_ptr;
// Bodenkacheln
unsigned char *water_ptr;
unsigned char *fels_ptr;
unsigned char *gras_ptr;
unsigned char *beton_ptr;

// Einstellungen
unsigned char sound_on;
int  base=0; // Basisadresse
char dma=0;  // DMA
char irq=0;  // IRQ
unsigned int  clear_buff_nr; // Nummer der zu lschenden Pufferstelle
unsigned int mousex, mousey, mouseb;
// Waves
struct wave_data{ // Struktur fr die Wavedatei
  unsigned int length; // Lnge
  unsigned char *data; // Zeiger auf die Daten
}waves[12];
// Enemys
struct{
  unsigned char typ;
  int hits;
  int x,y;
  unsigned char viewable;
  char fx,fy;
} enemys[50];
// Gebude
struct{
  unsigned char typ;
  int hits;
  int x,y;
  unsigned char viewable;
} haus[50];
// Black Eagle
struct{
  unsigned char name[17];
  int hits,max_hits;
  unsigned char mg_d,missel_d;
  unsigned char missel,reload_missel;
  unsigned char weapons,reload_mg;
  int x,y;
  char prozent;
  unsigned int money;
}be;
unsigned int mission_money;
// MG
struct{
  unsigned int x,y;
  char fy;
} mg_shoots[20];
// BE Missel
struct{
  unsigned char typ;
  unsigned int x,y;
  char fy;
} be_missel[6];
// Enemy-Missel
struct{
  int x,y;
} enemy_missel[10];
// Boden
unsigned char boden[3000];
int world_y;
unsigned char anni_nr;
unsigned char frames;
// Explo
struct{
  int x,y;
  unsigned char typ;
  unsigned char anni;
} explos[10];
// Plasma
struct{
  int x,y;
  int fx,fy;
} plasmas[10];

//////////////////////////////////////////////////////////////////////////
// Prototypen		 						//
//////////////////////////////////////////////////////////////////////////
void clear_buff(unsigned int clear_buff_nr);
void write_dsp(unsigned char wert);
char reset_dsp(int test);
char find_sb();
void init_irq();
void init_sb();
void restore_irq();
void close_sb();
void make_dma_buffer();
void load_wave(struct wave_data *wave,char *name);
void convert_wave(struct wave_data *wave);
void play();
void mix_on_buff(unsigned char nr);

void readmouse();
void setmousexy(unsigned int x, unsigned int y);
void setminmaxx(unsigned int min, unsigned int max);
void setminmaxy(unsigned int min, unsigned int max);
void setspeed(unsigned int speedx, unsigned int speedy, unsigned int doublespeed);

unsigned char getkey(void);

//////////////////////////////////////////////////////////////////////////
// Game			 						//
//////////////////////////////////////////////////////////////////////////
void create_enemy_missel(int x,int y){
unsigned char i;
for(i=0;i<10;i++){
  if(enemy_missel[i].y!=-100)continue;
  enemy_missel[i].y=y;
  enemy_missel[i].x=x;
  return;
}
}

void create_plasma(int x,int y,int fx,int fy){
unsigned char i;
for(i=0;i<10;i++){
  if(plasmas[i].y!=500)continue;
  plasmas[i].y=y;
  plasmas[i].x=x;
  plasmas[i].fy=fy;
  plasmas[i].fx=fx;
  return;
}
}

void make_haus(){
unsigned char i,k;
int y;
for(i=0;i<50;i++){
  if(haus[i].typ==255)continue;
  y=-haus[i].y+world_y+200;
  if(y>=-32&&!haus[i].viewable)haus[i].viewable=1;
  if(!haus[i].viewable)continue;
  for(k=0;k<32;k++){
    if(y<200&&y>=0){
      if(haus[i].viewable==1){
	memcpy(MK_FP(pixel_ptr,(y)*320+haus[i].x+4),MK_FP(haus_ptr,k*320+4+haus[i].typ*32),32U);
      }else{
	memcpy(MK_FP(pixel_ptr,(y)*320+haus[i].x+4),MK_FP(haus_ptr,(k+32*(anni_nr+1))*320+4+haus[i].typ*32),32U);
      }
    }
    y++;
  }
  if(y>22&&haus[i].viewable==1&&frames%25==0&&(haus[i].typ==4||haus[i].typ==5)){
    if(sound_on)mix_on_buff(4);
    if(be.y<y-18){
      create_plasma(haus[i].x+15,y-18,random(4)-2,-2);
    }else{
      create_plasma(haus[i].x+15,y-18,random(4)-2,2);
    }
  }

  if(world_y+200-haus[i].y>199){haus[i].typ=255;haus[i].viewable=0;}
}
}

void make_flare_up(unsigned int x,unsigned char y){
unsigned int temp;
unsigned char i,k;
for(i=0;i<7;i++){
  if(y+i>199)return;
  temp=(y+i)*320+x;
  for(k=0;k<3;k++){
    if((pixel_ptr[temp]%16)-6<=0||pixel_ptr[temp]-1==0){
      pixel_ptr[temp]=246;
    }else{
      pixel_ptr[temp]-=6;
    }
    temp++;
  }
}
for(i=7;i<10;i++){
  if(y+i>199)return;
  temp=(y+i)*320+x;
  for(k=0;k<3;k++){
    if(pixel_ptr[temp]%16-(5-i+6)<=0||pixel_ptr[temp]-5-i+6==0){
      pixel_ptr[temp]=246;
    }else{
      pixel_ptr[temp]-=5-i+6;
    }
    temp++;
  }
}
}

void make_flare_down(unsigned int x,unsigned char y){
unsigned int temp;
char i,k;
for(i=0;i>-7;i--){
  if(y+i<=0)return;
  if(y+i>199)continue;
  temp=(y+i)*320+x;
  for(k=0;k<3;k++){
    if((pixel_ptr[temp]%16)-6<=0||pixel_ptr[temp]-1==0){
      pixel_ptr[temp]=246;
    }else{
      pixel_ptr[temp]-=6;
    }
    temp++;
  }
}
for(i=-7;i>-10;i--){
  if(y+i>199)continue;
  if(y+i<=0)return;
  temp=(y+i)*320+x;
  for(k=0;k<3;k++){
    if(pixel_ptr[temp]%16-(5+i+6)<=0||pixel_ptr[temp]-5+i+6==0){
      pixel_ptr[temp]=246;
    }else{
      pixel_ptr[temp]-=5+i+6;
    }
    temp++;
  }
}
}

void make_boden(){
unsigned int off_y,off_x,off_tex;
unsigned char y,i;
off_tex=(world_y/32)*10;
for(i=0;i<80;i++){
  off_x=(i%10)*32;
  off_y=(i/10)*32+32-world_y%32;
  for(y=0;y<32;y++){
    if(y+200-off_y<200){
      if(boden[i+off_tex]==0) // Wasser 1
	memcpy(MK_FP(pixel_ptr,(y+200-off_y)*320+off_x+4),MK_FP(water_ptr,4+anni_nr*32+y*96),32U);
      if(boden[i+off_tex]==1) // Wasser 2
	memcpy(MK_FP(pixel_ptr,(y+200-off_y)*320+off_x+4),MK_FP(water_ptr,4+((unsigned)2-anni_nr)*32+y*96),32U);
      if(boden[i+off_tex]>1&&boden[i+off_tex]<30){ // Felsen
	memcpy(MK_FP(pixel_ptr,(y+200-off_y)*320+off_x+4),MK_FP(fels_ptr,4+(boden[i+off_tex]-2)*32+y*896),32U);
      }
      if(boden[i+off_tex]>29&&boden[i+off_tex]<58){ // Gras
	memcpy(MK_FP(pixel_ptr,(y+200-off_y)*320+off_x+4),MK_FP(gras_ptr,4+(boden[i+off_tex]-30)*32+y*896),32U);
      }
      if(boden[i+off_tex]>57&&boden[i+off_tex]<73){ // Beton
	memcpy(MK_FP(pixel_ptr,(y+200-off_y)*320+off_x+4),MK_FP(beton_ptr,4+(boden[i+off_tex]-58)*32+y*480),32U);
      }
      if(boden[i+off_tex]>128)break;
    }
  }
}
}

void make_expl(){
unsigned char i,y,x;
for(i=0;i<10;i++){
  if(explos[i].typ!=255){
    if(frames%2==0)
      explos[i].y++;
    for(y=0;y<32;y++)
      for(x=0;x<32;x++)
	if((y+explos[i].y)<200&&x+explos[i].x<320&&x+explos[i].x>=0&&(y+explos[i].y)>=0)
	  if(exp_ptr[(y+32*explos[i].typ)*224+x+32*(explos[i].anni/7)]!=255){
	    pixel_ptr[(y+explos[i].y)*320+x+explos[i].x]=exp_ptr[(y+32*explos[i].typ)*224+x+32*(explos[i].anni/7)];
	  }
    explos[i].anni++;
    if(explos[i].anni==49)explos[i].typ=255;
  }
}
}

void add_expl(int x,int y){
unsigned char i;
for(i=0;i<10;i++){
  if(explos[i].typ==255){
    explos[i].typ=random(4);
    explos[i].x=x;
    explos[i].y=y;
    explos[i].anni=0;
    return;
  }
}
}

void make_shoots(){
unsigned char i,k,j,t;
// MG
for(i=0;i<20;i++){
  if(mg_shoots[i].y+mg_shoots[i].fy>199)mg_shoots[i].y=500;
  if(mg_shoots[i].y!=500){
    mg_shoots[i].y+=mg_shoots[i].fy;

    // burning down the haus!!!
    for(k=0;k<50;k++){
      if(haus[k].viewable==1&&
	 haus[k].x<=mg_shoots[i].x&&haus[k].x+32>=mg_shoots[i].x&&
	 -haus[k].y+world_y+200+32>=mg_shoots[i].y&&-haus[k].y+world_y+200<=mg_shoots[i].y){

	   pixel_ptr[(mg_shoots[i].y+1)*320+mg_shoots[i].x]=180;
	   pixel_ptr[(mg_shoots[i].y)*320+mg_shoots[i].x+1]=180;
	   pixel_ptr[(mg_shoots[i].y)*320+mg_shoots[i].x-1]=180;
	   pixel_ptr[(mg_shoots[i].y+2)*320+mg_shoots[i].x+1]=180;
	   pixel_ptr[(mg_shoots[i].y+2)*320+mg_shoots[i].x-1]=180;

	   haus[k].hits--;
	   if(haus[k].hits<=0){
	     haus[k].viewable=2;
	     if(sound_on)mix_on_buff(6);

	     add_expl(haus[k].x,-haus[k].y+world_y+200);
	     add_expl(haus[k].x+random(30)-15,-haus[k].y+world_y+200+random(30)-15);
	     add_expl(haus[k].x+random(30)-15,-haus[k].y+world_y+200+random(30)-15);
	     add_expl(haus[k].x+random(30)-15,-haus[k].y+world_y+200+random(30)-15);

	     if(mission_money<64000)mission_money+=200;
	     if(haus[k].typ>=2&&haus[k].typ<=5)
	       if(mission_money<64000)mission_money+=150;
	     if(haus[k].typ==6)
	       if(mission_money<64000)mission_money+=1000;
	   }

	   mg_shoots[i].y=500;
	 }
    }
    // Blow them away
    for(k=0;k<50;k++){
      switch(enemys[k].typ){
	case 0:t=22;break;
	case 1:t=31;break;
	case 2:t=25;break;
	case 3:t=32;break;
	case 4:t=26;break;
	case 5:t=28;break;
	case 6:t=21;break;
      }
      if(enemys[k].viewable&&
	 mg_shoots[i].y>-enemys[k].y+200&&mg_shoots[i].y<-enemys[k].y+200+22&&
	 mg_shoots[i].x<enemys[k].x+t&&mg_shoots[i].x>enemys[k].x){

	   pixel_ptr[(mg_shoots[i].y+1)*320+mg_shoots[i].x]=180;
	   pixel_ptr[(mg_shoots[i].y)*320+mg_shoots[i].x+1]=180;
	   pixel_ptr[(mg_shoots[i].y)*320+mg_shoots[i].x-1]=180;
	   pixel_ptr[(mg_shoots[i].y+2)*320+mg_shoots[i].x+1]=180;
	   pixel_ptr[(mg_shoots[i].y+2)*320+mg_shoots[i].x-1]=180;
	   enemys[k].hits--;

	   mg_shoots[i].y=500;
      }
    }

    pixel_ptr[mg_shoots[i].y*320+mg_shoots[i].x]=1;
    pixel_ptr[(mg_shoots[i].y+1)*320+mg_shoots[i].x]=10;
  }
}
// BE Missels
for(i=0;i<6;i++){
if(be_missel[i].typ==0){
// LL
  if(be_missel[i].y+be_missel[i].fy>199&&be_missel[i].y+be_missel[i].fy<65525)be_missel[i].y=500;
  if(be_missel[i].y!=500){
    be_missel[i].y+=be_missel[i].fy;

    make_flare_up(be_missel[i].x,be_missel[i].y+10);

    for(j=0;j<10;j++)
      if(j+be_missel[i].y<200)
      for(k=0;k<4;k++)
	if(be_missel_ptr[j*4+k]!=255)
	  pixel_ptr[(j+be_missel[i].y)*320+k+be_missel[i].x]=be_missel_ptr[j*4+k];

    // Blow them away (by missel)
    for(k=0;k<50;k++){
      switch(enemys[k].typ){
	case 0:t=22;break;
	case 1:t=31;break;
	case 2:t=25;break;
	case 3:t=32;break;
	case 4:t=26;break;
	case 5:t=28;break;
	case 6:t=21;break;
      }
      if(enemys[k].viewable&&
	 be_missel[i].y>-enemys[k].y+200&&be_missel[i].y<-enemys[k].y+200+22&&
	 be_missel[i].x<enemys[k].x+t&&be_missel[i].x>enemys[k].x){

	   enemys[k].hits-=10;

	   be_missel[i].y=500;
      }
    }
  }
}else{
// LB
  if(be_missel[i].y+be_missel[i].fy>199&&be_missel[i].y+be_missel[i].fy<65525)be_missel[i].y=500;
  if(be_missel[i].y!=500){
    be_missel[i].y+=be_missel[i].fy;

    make_flare_up(be_missel[i].x,be_missel[i].y+10);

    for(j=0;j<10;j++)
      if(j+be_missel[i].y<200)
      for(k=0;k<4;k++)
	if(be_missel2_ptr[j*4+k]!=255)
	  pixel_ptr[(j+be_missel[i].y)*320+k+be_missel[i].x]=be_missel2_ptr[j*4+k];

    // Burning down the haus!!! (by missel)
    for(k=0;k<50;k++){
      if(haus[k].viewable==1&&
	 haus[k].x<=be_missel[i].x&&haus[k].x+32>=be_missel[i].x&&
	 -haus[k].y+world_y+200+32>=be_missel[i].y&&-haus[k].y+world_y+200<=be_missel[i].y){

	   haus[k].hits-=20;
	   if(haus[k].hits<=0){
	     haus[k].viewable=2;
	     if(sound_on)mix_on_buff(6);

	     add_expl(haus[k].x,-haus[k].y+world_y+200);
	     add_expl(haus[k].x+random(30)-15,-haus[k].y+world_y+200+random(30)-15);
	     add_expl(haus[k].x+random(30)-15,-haus[k].y+world_y+200+random(30)-15);
	     add_expl(haus[k].x+random(30)-15,-haus[k].y+world_y+200+random(30)-15);

	     if(mission_money<64000)mission_money+=200;
	     if(mission_money<64000)mission_money+=100;
	     if(haus[k].typ>=2&&haus[k].typ<=5)
	       if(mission_money<64000)mission_money+=150;
	     if(haus[k].typ==6)
	       if(mission_money<64000)mission_money+=1000;
	   }

	   be_missel[i].y=500;
	 }
    }
  }
}
}

// Plasma
for(i=0;i<10;i++){
  if(plasmas[i].y==500)continue;
  for(j=0;j<6;j++)
    if(j+plasmas[i].y<200&&j+plasmas[i].y>=0)
      for(k=0;k<6;k++)
	if(plasma_ptr[j*6+k]!=255&&k+plasmas[i].x<320&&k+plasmas[i].x>=0)
	  pixel_ptr[(j+plasmas[i].y)*320+k+plasmas[i].x]=plasma_ptr[j*6+k];
   plasmas[i].y+=plasmas[i].fy;
   plasmas[i].x+=plasmas[i].fx;
   if(plasmas[i].x>be.x+5&&plasmas[i].x<be.x+20&&plasmas[i].y>be.y&&plasmas[i].y<be.y+30){
     plasmas[i].y=500;
     if(sound_on)mix_on_buff(9);
     be.hits-=2;
     be.prozent=(be.hits*100)/be.max_hits;
   }
   if(plasmas[i].x<10||plasmas[i].x>320||plasmas[i].y>200||plasmas[i].y<6)
     plasmas[i].y=500;
}
// Enemy Missels
for(i=0;i<10;i++){
  if(enemy_missel[i].y==-100)continue;

  for(j=0;j<10;j++)
    if(j+enemy_missel[i].y<200&&j+enemy_missel[i].y>=0)
      for(k=0;k<4;k++)
	if(enemy_missel_ptr[j*4+k]!=255&&k+enemy_missel[i].x<320&&k+enemy_missel[i].x>=0)
	  pixel_ptr[(j+enemy_missel[i].y)*320+k+enemy_missel[i].x]=enemy_missel_ptr[j*4+k];
   enemy_missel[i].y+=4;
   make_flare_down(enemy_missel[i].x,enemy_missel[i].y);
   if(enemy_missel[i].x>be.x+4&&enemy_missel[i].x<be.x+21&&enemy_missel[i].y>be.y&&enemy_missel[i].y<be.y+30){
     enemy_missel[i].y=-100;
     if(sound_on)mix_on_buff(9);
     be.hits-=10;
     be.prozent=(be.hits*100)/be.max_hits;
   }
   if(enemy_missel[i].x<10||enemy_missel[i].x>320||enemy_missel[i].y>200||enemy_missel[i].y<6)
     enemy_missel[i].y=-100;
}
}

void mg_shoot(int *msx){
unsigned char i,nr=0;
for(i=0;i<20;i++){
  if(mg_shoots[i].y==500){
    if(nr==0){
      mg_shoots[i].x=be.x+7;
      mg_shoots[i].y=be.y+10;
    }else{
      if(*msx<0){
	mg_shoots[i].x=be.x+11;
      }else{
	if(*msx>0){
	  mg_shoots[i].x=be.x+4;
	}else{
	  mg_shoots[i].x=be.x+18;
	}
      }
      mg_shoots[i].y=be.y+10;
    }
    mg_shoots[i].fy=-10;
    nr++;
    if(nr==2)return;
  }
}
}

void be_missel_shoot(int *msx){
unsigned char i,nr=0;
for(i=0;i<6;i++){
  if(be_missel[i].y==500){
    if(nr==0){
      be_missel[i].x=be.x+4;
      be_missel[i].y=be.y+10;
    }else{
      if(*msx<0||*msx>0){
	be_missel[i].x=be.x+11;
      }else{
	be_missel[i].x=be.x+18;
      }
      be_missel[i].y=be.y+10;
    }
    be_missel[i].fy=-4;
    be_missel[i].typ=be.missel;
    nr++;
    if(nr==2)return;
  }
}
}

void make_enemys(){
unsigned char i,x,y;
char shadow_off_x,shadow_off_y;
int ry;
for(i=0;i<50;i++){
  if(enemys[i].typ==255)continue;
  if(frames%2==0&&!enemys[i].viewable){
    enemys[i].y--;
  }
  if(enemys[i].y<250){
    if(!enemys[i].viewable){
      enemys[i].viewable=1;
    }else{
      if(-enemys[i].y+200>0){
	if(frames%2==0)enemys[i].y-=enemys[i].fy;
      }else{
	if(frames%2==0)enemys[i].y-=enemys[i].fy;
      }

      switch(enemys[i].typ){
	case 0:y=22;break;
	case 1:y=31;break;
	case 2:y=25;break;
	case 3:y=32;break;
	case 4:y=26;break;
	case 5:y=28;break;
	case 6:y=21;break;
      }
      if(enemys[i].x-enemys[i].fx<0||enemys[i].x-enemys[i].fx>=320-y)enemys[i].fx*=-1;
      if(frames%2==0)enemys[i].x-=enemys[i].fx;
      if(enemys[i].y<-20){enemys[i].typ=255;enemys[i].viewable=0;continue;}
      ///////////
      // TYP 0 //
      ///////////
      if(enemys[i].typ==0){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<16;y++)
	  for(x=0;x<16;x++)
	    if(enemy_ptr[(22+y)*186+x]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<22;y++){
	  ry++;
	  for(x=0;x<22;x++){
	    if(enemy_ptr[y*186+x]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x];
	  }
	}
	make_flare_down(enemys[i].x+3,-enemys[i].y+200);
	make_flare_down(enemys[i].x+15,-enemys[i].y+200);
	// SHOOT
	if(frames%50==0){
	  if(sound_on)mix_on_buff(4);
	  create_plasma(enemys[i].x+8,-enemys[i].y+200+18,1,2);
	  create_plasma(enemys[i].x+8,-enemys[i].y+200+18,-1,2);
	}
	// Stupid death
	if(enemys[i].x+22>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+22>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=250;
	  continue;
	}
	continue;
      }
      ///////////
      // TYP 1 //
      ///////////
      if(enemys[i].typ==1){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<21;y++)
	  for(x=0;x<22;x++)
	    if(enemy_ptr[(30+y)*186+x+22]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<29;y++){
	  ry++;
	  for(x=0;x<30;x++){
	    if(enemy_ptr[y*186+x+22]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+22];
	  }
	}
	make_flare_down(enemys[i].x+8,-enemys[i].y+200);
	make_flare_down(enemys[i].x+11,-enemys[i].y+200);
	make_flare_down(enemys[i].x+17,-enemys[i].y+200);
	make_flare_down(enemys[i].x+20,-enemys[i].y+200);

	// SHOOT
	if(frames%50==0){
	  if(sound_on)mix_on_buff(10);
	  create_enemy_missel(enemys[i].x+9,-enemys[i].y+200+18);
	  create_enemy_missel(enemys[i].x+20,-enemys[i].y+200+18);
	}
	// Stupid death
	if(enemys[i].x+30>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+29>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=500;
	  continue;
	}
	continue;
      }
      ///////////
      // TYP 2 //
      ///////////
      if(enemys[i].typ==2){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<17;y++)
	  for(x=0;x<18;x++)
	    if(enemy_ptr[(24+y)*186+x+53]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<24;y++){
	  ry++;
	  for(x=0;x<25;x++){
	    if(enemy_ptr[y*186+x+53]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+53];
	  }
	}
	make_flare_down(enemys[i].x+2,-enemys[i].y+200);
	make_flare_down(enemys[i].x+20,-enemys[i].y+200);

	// SHOOT
	if(frames%50==0){
	  if(sound_on)mix_on_buff(4);
	  create_plasma(enemys[i].x+10,-enemys[i].y+200+13,0,2);
	}
	// Stupid death
	if(enemys[i].x+30>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+29>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=250;
	  continue;
	}
	continue;
      }
      ///////////
      // TYP 3 //
      ///////////
      if(enemys[i].typ==3){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<14;y++)
	  for(x=0;x<22;x++)
	    if(enemy_ptr[(20+y)*186+x+78]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<20;y++){
	  ry++;
	  for(x=0;x<32;x++){
	    if(enemy_ptr[y*186+x+78]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+78];
	  }
	}
	make_flare_down(enemys[i].x+1,-enemys[i].y+200);
	make_flare_down(enemys[i].x+4,-enemys[i].y+200);
	make_flare_down(enemys[i].x+7,-enemys[i].y+200);
	make_flare_down(enemys[i].x+22,-enemys[i].y+200);
	make_flare_down(enemys[i].x+25,-enemys[i].y+200);
	make_flare_down(enemys[i].x+28,-enemys[i].y+200);

	// SHOOT
	if(frames%50==0){
	  if(sound_on)mix_on_buff(4);
	  create_plasma(enemys[i].x,-enemys[i].y+200+20,0,2);
	  create_plasma(enemys[i].x+27,-enemys[i].y+200+20,0,2);
	}
	// Stupid death
	if(enemys[i].x+32>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+29>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=600;
	  continue;
	}
	continue;
      }
      ///////////
      // TYP 4 //
      ///////////
      if(enemys[i].typ==4){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<21;y++)
	  for(x=0;x<18;x++)
	    if(enemy_ptr[(30+y)*186+x+110]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<30;y++){
	  ry++;
	  for(x=0;x<26;x++){
	    if(enemy_ptr[y*186+x+110]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+110];
	  }
	}
	// SHOOT
	if(frames%50==0){
	  if(sound_on)mix_on_buff(4);
	  if(be.y<-enemys[i].y+200){
	    create_plasma(enemys[i].x+13,-enemys[i].y+200+15,random(4)-2,-2);
	    create_plasma(enemys[i].x+13,-enemys[i].y+200+15,random(4)-2,-2);
	    create_plasma(enemys[i].x+13,-enemys[i].y+200+15,random(4)-2,-2);
	  }else{
	    create_plasma(enemys[i].x+13,-enemys[i].y+200+15,random(4)-2,2);
	    create_plasma(enemys[i].x+13,-enemys[i].y+200+15,random(4)-2,2);
	    create_plasma(enemys[i].x+13,-enemys[i].y+200+15,random(4)-2,2);
	  }
	}
	// Stupid death
	if(enemys[i].x+26>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+30>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=750;
	  continue;
	}
	continue;
      }
      ///////////
      // TYP 5 //
      ///////////
      if(enemys[i].typ==5){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<20;y++)
	  for(x=0;x<19;x++)
	    if(enemy_ptr[(32+y)*186+x+136]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<32;y++){
	  ry++;
	  for(x=0;x<28;x++){
	    if(enemy_ptr[y*186+x+136]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+136];
	  }
	}
	make_flare_down(enemys[i].x+7,-enemys[i].y+200);
	make_flare_down(enemys[i].x+18,-enemys[i].y+200);

	// SHOOT
	if(frames%50==0){
	  if(sound_on)mix_on_buff(4);
	  if(sound_on)mix_on_buff(10);
	  create_plasma(enemys[i].x+12,-enemys[i].y+200+30,0,2);
	  create_enemy_missel(enemys[i].x+5,-enemys[i].y+200+15);
	  create_enemy_missel(enemys[i].x+21,-enemys[i].y+200+15);
	}
	// Stupid death
	if(enemys[i].x+28>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+30>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=900;
	  continue;
	}
	continue;
      }
      ///////////
      // TYP 6 //
      ///////////
      if(enemys[i].typ==6){
	// SHADOW
	shadow_off_x=(176-enemys[i].x)/7;
	shadow_off_y=(120+enemys[i].y-200)/7;
	for(y=0;y<15;y++)
	  for(x=0;x<15;x++)
	    if(enemy_ptr[(22+y)*186+x+164]!=255&&(-enemys[i].y+200+y+shadow_off_y)<200&&(-enemys[i].y+200+y+shadow_off_y)>=0){
	      ry=(-enemys[i].y+200+y+shadow_off_y)*320+x+enemys[i].x+shadow_off_x;
	      if(((pixel_ptr[ry]+1)%16)+5>15||pixel_ptr[ry]+5==255||(pixel_ptr[ry]%16)==15||pixel_ptr[ry]==0){
		pixel_ptr[ry]=0;
	      }else{
		pixel_ptr[ry]+=5;
	      }
	    }
	// PAINT
	ry=-enemys[i].y+200;
	for(y=0;y<22;y++){
	  ry++;
	  for(x=0;x<22;x++){
	    if(enemy_ptr[y*186+x+164]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+164];
	  }
	}
	// Stupid death
	if(enemys[i].x+25>be.x+7&&enemys[i].x<be.x+18&&-enemys[i].y+200+21>be.y&&-enemys[i].y+200<be.y+30){
	  be.hits-=enemys[i].hits;
	  be.prozent=(be.hits*100)/be.max_hits;
	  enemys[i].hits=0;
	}
	// BUMM
	if(-enemys[i].y+200>=6&&enemys[i].hits<=0){
	  if(sound_on)mix_on_buff(3);
	  add_expl(enemys[i].x-6,-enemys[i].y+200-6);
	  enemys[i].typ=255;
	  enemys[i].viewable=0;
	  if(mission_money<64000)mission_money+=750;
	  continue;
	}
	continue;
      }

    }
  }
}
}

void make_hud(){
unsigned char i,k;
if(be.weapons!=0)
  for(i=0;i<16;i++){
    for(k=0;k<12;k++){
      if(hud_ptr[i*112+k+12*(be.missel)]!=255)
	pixel_ptr[i*320+k]=hud_ptr[i*112+k+12*(be.missel)];
    }
  }
for(i=0;i<11;i++)
  for(k=0;k<8;k++)
    if(hud_ptr[i*112+k+94]!=255)
      pixel_ptr[i*320+k+184]=hud_ptr[i*112+k+94];
for(i=0;i<11;i++)
  for(k=0;k<10;k++)
    if(hud_ptr[i*112+k+102]!=255)
      pixel_ptr[i*320+k+310]=hud_ptr[i*112+k+102];
if(be.prozent==100)
  for(i=0;i<11;i++)
    for(k=0;k<7;k++)
      if(hud_ptr[i*112+k+31]!=255)
	pixel_ptr[i*320+k+289]=hud_ptr[i*112+k+31];
if(be.prozent>9)
  for(i=0;i<11;i++)
    for(k=0;k<7;k++)
      if(hud_ptr[i*112+k+24+7*((be.prozent%100)/10)]!=255)
	pixel_ptr[i*320+k+296]=hud_ptr[i*112+k+24+7*((be.prozent%100)/10)];
for(i=0;i<11;i++)
  for(k=0;k<7;k++)
    if(hud_ptr[i*112+k+24+7*(be.prozent%10)]!=255)
      pixel_ptr[i*320+k+303]=hud_ptr[i*112+k+24+7*(be.prozent%10)];


for(i=0;i<11;i++)
  for(k=0;k<7;k++)
    if(hud_ptr[i*112+k+24+7*((be.money+mission_money)%10)]!=255)
      pixel_ptr[i*320+k+177]=hud_ptr[i*112+k+24+7*((be.money+mission_money)%10)];
if((be.money+mission_money)>9){
  for(i=0;i<11;i++)
    for(k=0;k<7;k++)
      if(hud_ptr[i*112+k+24+7*(((be.money+mission_money)/10)%10)]!=255)
	pixel_ptr[i*320+k+170]=hud_ptr[i*112+k+24+7*(((be.money+mission_money)/10)%10)];
}else return;
if((be.money+mission_money)>99){
  for(i=0;i<11;i++)
    for(k=0;k<7;k++)
      if(hud_ptr[i*112+k+24+7*(((be.money+mission_money)/100)%10)]!=255)
	pixel_ptr[i*320+k+163]=hud_ptr[i*112+k+24+7*(((be.money+mission_money)/100)%10)];
}else return;
if((be.money+mission_money)>999){
  for(i=0;i<11;i++)
    for(k=0;k<7;k++)
      if(hud_ptr[i*112+k+24+7*(((be.money+mission_money)/1000)%10)]!=255)
	pixel_ptr[i*320+k+156]=hud_ptr[i*112+k+24+7*(((be.money+mission_money)/1000)%10)];
}else return;
if((be.money+mission_money)>9999)
  for(i=0;i<11;i++)
    for(k=0;k<7;k++)
      if(hud_ptr[i*112+k+24+7*((be.money+mission_money)/10000)]!=255)
	pixel_ptr[i*320+k+149]=hud_ptr[i*112+k+24+7*((be.money+mission_money)/10000)];
}

void retrace() {
asm {
  MOV DX,0x3DA
}
q1:
asm{
  IN AL,DX
  TEST AL,0x08
  JNZ q1
}
q2:
asm{
  IN AL,DX
  TEST AL,0x08
  JZ q2
}}

int game(){
unsigned char taste=0,off,range,shoot=0,reload_mg=0,reload_missel=0;
unsigned int i,k,temp;
int msx=0,msy=0,l_fx=0;
char shadow_off_x,shadow_off_y,end=0,lm=0;

mission_money=0;

for(i=0;i<20;i++)
  mg_shoots[i].y=500;
for(i=0;i<6;i++)
  be_missel[i].y=500;
for(i=0;i<10;i++)
  enemy_missel[i].y=-100;

randomize();
world_y=0;
anni_nr=0;
frames=0;

for(i=0;i<10;i++)
  explos[i].typ=255;

for(i=0;i<10;i++)
  plasmas[i].y=500;

setminmaxx(0,16);
setminmaxy(0,16);
setmousexy(8,8);
setspeed(25,25,50);
be.x=150;
be.y=170;

while(taste!=0x81){
  if(!end)taste=getkey();
  if(!end)readmouse();

  msx=(signed)mousex-8;
  msy=(signed)mousey-8;
  setmousexy(8,8);

  if(msx>18)msx=18;
  if(msy>16)msy=16;
  if(msx<-18)msx=-18;
  if(msy<-16)msy=-16;

  be.x+=msx;
  be.y+=msy;

  off=0;
  range=26;
  if(msx==0&&l_fx>0)l_fx--;
  if(msx==0&&l_fx<0)l_fx++;
  if(msx<0&&l_fx>-15)l_fx--;
  if(msx>0&&l_fx<15)l_fx++;
  if(l_fx<-6){off=52;range=16;}
  if(l_fx>6){off=85;range=16;}

  if(be.x<0)be.x=0;
  if(be.x>294)be.x=294;
  if(be.y<0)be.y=0;
  if(be.y>170)be.y=170;

  if(mouseb&0x1){shoot=1;}else{shoot=0;}
  if(mouseb&0x2&&!lm&&be.weapons>1){if(sound_on)mix_on_buff(1);be.missel^=1;}
  lm=mouseb&0x2;

  // Paint Boden
  make_boden();
  // Paint Haus
  make_haus();
  // Paint Bum
  make_expl();

  // Shadows
  shadow_off_x=(176-be.x)/7;
  shadow_off_y=(120-be.y)/7;
  for(i=0;i<range-5;i++)
    for(k=0;k<21;k++)
      if(be_ptr[(i+off)+(k+30)*116]!=255){
	  temp=(k+be.y+shadow_off_y)*320+i+be.x+shadow_off_x;
	  if(((pixel_ptr[temp]+1)%16)+5>15||pixel_ptr[temp]+5==255||(pixel_ptr[temp]%16)==15||pixel_ptr[temp]==0){
	    pixel_ptr[temp]=0;
	  }else{
	    pixel_ptr[temp]+=5;
	  }
	}

  // Shoots
  if(shoot){
    // mg
    if(reload_mg==0){
      if(off!=0)off+=15;
      if(off==0)off+=26;
      if(sound_on)mix_on_buff(9);
      mg_shoot(&msx);
      reload_mg=be.reload_mg;
    }
    if(reload_missel==0&&be.weapons!=0){
      if(sound_on)mix_on_buff(10);
      be_missel_shoot(&msx);
      reload_missel=be.reload_missel;
    }
  }
  if(reload_missel!=0)reload_missel--;
  if(reload_mg!=0)reload_mg--;

  // Paint Enemys
  make_enemys();
  // Paint Shoots
  make_shoots();

  // Paint Planes
  for(i=0;i<range;i++)
    for(k=0;k<30;k++)
      if(be_ptr[(i+off)+k*116]!=255)pixel_ptr[(k+be.y)*320+i+be.x]=be_ptr[(i+off)+k*116];

  if(off<40){
    make_flare_up(be.x+8,be.y+30);
    make_flare_up(be.x+15,be.y+30);
  }else{
    if(off<80){
      make_flare_up(be.x+5,be.y+30);
      make_flare_up(be.x+9,be.y+30);
    }else{
      make_flare_up(be.x+4,be.y+30);
      make_flare_up(be.x+8,be.y+30);
    }
  }

  // Der Hut
  make_hud();

  retrace();
  // Animationen
  if(frames%50==0)anni_nr++;
  if(anni_nr>2)anni_nr=0;
  // Frames
  frames++;
  if(world_y<3000){
    if(frames%2==0)world_y++;
  }else{
    if(world_y==3000){
      if(sound_on)mix_on_buff(5);
      world_y++;
      end=1;
    }
    if(be.y>4){
      be.y-=4;
    }else{
      if(be.money+mission_money<=64000){
	be.money+=mission_money;
      }else{
	be.money=mission_money;
      }
      return 0;
    }
  }
  if(frames>99)frames=0;

  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
  if(be.hits<=0)return 1;
}
return 0;
}

//////////////////////////////////////////////////////////////////////////
// Grafik	 							//
//////////////////////////////////////////////////////////////////////////
void pal(char *file){
unsigned char string[3]={255,255,255};
unsigned char palette[256*3];
unsigned char temp;
int k,i,j;
FILE *fp;
fp=fopen(file,"r");
fseek(fp, 21+5, SEEK_SET);
i=0;
k=0;
j=0;
do{
temp = fgetc(fp);
if(temp!=32&&temp!=10){
string[k]=temp;
k++;
}else{
if(string[2]==255&&string[1]==255&&string[0]!=255){palette[i*3+j]=string[0]-48;}
else{
  if(string[2]==255&&string[1]!=255&&string[0]!=255){palette[i*3+j]=((string[0]-48)*10)+(string[1]-48);}
  else{
    palette[i*3+j]=((string[0]-48)*100)+((string[1]-48)*10)+(string[2]-48);
  }
}
palette[i*3+j]/=4;
string[2]=255;string[1]=255;string[0]=255;
k=0;j++;}
if(j==3){j=0;i++;string[2]=255;string[1]=255;string[0]=255;}
}while(temp!=255);
fclose(fp);
outp(0x03c8,0);
for(i=0;i<256*3;i++)
  outp(0x03c9,palette[i]);
}

void fade_pal(char *file,unsigned char out){
unsigned char string[3]={255,255,255};
unsigned char palette[256*3],palette_fade[256*3];
unsigned char temp;
int k,i,j;
FILE *fp;
fp=fopen(file,"r");
fseek(fp, 21+5, SEEK_SET);
i=0;
k=0;
j=0;
do{
temp = fgetc(fp);
if(temp!=32&&temp!=10){
string[k]=temp;
k++;
}else{
if(string[2]==255&&string[1]==255&&string[0]!=255){palette[i*3+j]=string[0]-48;}
else{
  if(string[2]==255&&string[1]!=255&&string[0]!=255){palette[i*3+j]=((string[0]-48)*10)+(string[1]-48);}
  else{
    palette[i*3+j]=((string[0]-48)*100)+((string[1]-48)*10)+(string[2]-48);
  }
}
palette[i*3+j]/=4;
string[2]=255;string[1]=255;string[0]=255;
k=0;j++;}
if(j==3){j=0;i++;string[2]=255;string[1]=255;string[0]=255;}
}while(temp!=255);
fclose(fp);

if(!out){
for(i=0;i<256*3;i++)
  palette_fade[i]=0;
for(k=0;k<64;k++){
  delay(10);
  outp(0x03c8,0);
  for(i=0;i<256*3;i++){
    if(palette_fade[i]!=palette[i])palette_fade[i]++;
    outp(0x03c9,palette_fade[i]);
  }
}
}else{
for(k=0;k<64;k++){
  delay(10);
  outp(0x03c8,0);
  for(i=0;i<256*3;i++){
    if(palette[i]>0)palette[i]--;
    outp(0x03c9,palette[i]);
  }
}
}
}

void pcx(char *file,unsigned char *_ptr,unsigned int x,unsigned int y){
int k,i,z,j;
unsigned char temp;
FILE *fp;
fp = fopen(file,"rb");

i=0;
k=0;
fseek(fp, 128+5, SEEK_SET);
do{
  temp = fgetc(fp);
  if(temp>191){
    z=temp-192;
    temp = fgetc(fp);
    for(j=0;j<z;j++){
      _ptr[k+i*x]=temp;
      k++;
      if(k==x)break;
    }
  }else{
    _ptr[k+i*x]=temp;
    k++;
  }
  if(k==x){k=0;i++;}
}while(i!=y);
fclose(fp);
}

//////////////////////////////////////////////////////////////////////////
// Sound	 							//
//////////////////////////////////////////////////////////////////////////
void interrupt (*old_irq)(...); // alter Interrupt
void interrupt erazor(...){ // neuer Interrupt
inportb(base+0xE); // Interrupt besttigen
outportb(0x20,0x20);
if(irq==2||irq==10||irq==11)outportb(0xA0,0x20); // nochmal falls IRQ 2|10|11
// Den Bereich auf dem Puffer lschen der gerade gespielt wurde.
clear_buff_nr++;
//clear_buff_nr&=3;
clear_buff_nr&=31;
clear_buff(clear_buff_nr);
}
void clear_buff(unsigned int clear_buff_nr){
char *adresse;
adresse=(char *)MK_FP(FP_SEG(dma_buffer_ptr),FP_OFF(dma_buffer_ptr)+(clear_buff_nr<<10));
memset(adresse,128,1024);
}
void write_dsp(unsigned char wert){
// Warten bis Bit 7 vom WRITE BUFFER STATUS Port 0 ist
while((inportb(base+0xC)&0x80)>>7);
// Daten senden an den WRITE COMMAND/DATA Port
outportb(base+0xC,wert);
}
char reset_dsp(int test){
// Reset des Digitalen Sound Prozessors
outportb(test+0x6,1); // Resetport 2?6h
delay(10); // eigentlich zu lange, aber warum nicht
outportb(test+0x6,0);
delay(10);
// Der Reset war erfolgreich, wenn am DATA AVAILABLE Port 2?Eh das
// 7. Bit 1 ist und am READ DATA Port 2?Ah ein AAh anliegt.
if(((inportb(test+0xE)&0x80)>>7)&&(inportb(test+0xA)==0xAA)){
  // Jo hier isser
  base=test;
  return 1;
}
// nicht gefunden
return 0;
}
char find_sb (){
char temp;
char *blaster_var;
// suchen der Basisadresse (210h,220h,230h,240h,250h,260h,280h)
for(temp=1;temp<9;temp++){
  if(temp!=7) // 270h nicht prfen
    if(reset_dsp(0x200+(temp<<4))){ // temp * 16 und prfen
      break;
    }
}
if(temp==9)return 0; // keine Adresse gefunden
// suchen des IRQ und des DMA in der Blaster Umgebungsvariable
blaster_var=getenv("BLASTER");
for(temp=0;temp<strlen(blaster_var);temp++){
  if((blaster_var[temp]|32)=='d') // Kleinbuchstabe d gefunden
    dma=blaster_var[temp+1]-'0'; // das nchste Zeichen ist der DMA
  if((blaster_var[temp]|32)=='i'){ // Kleinbuchstabe i gefunden
    irq=blaster_var[temp+1]-'0'; // das nchste Zeichen ist der IRQ
    if(blaster_var[temp+2]!=' ') // Zweistelliger IRQ
      irq=irq*10+blaster_var[temp+2]-'0'; // zweite Stelle einlesen
    }
}
return 1;
}
void init_irq(){
// sichern des alten Interrupts in old_irq
if(irq==2||irq==10||irq==11){
  if(irq==2)  old_irq=getvect(0x71);
  if(irq==10) old_irq=getvect(0x72);
  if(irq==11) old_irq=getvect(0x73);
}else old_irq=getvect(8+irq);
// setzen des neuen Interrupts erazor
if(irq==2||irq==10||irq==11){
  if(irq==2)  setvect(0x71,erazor);
  if(irq==10) setvect(0x72,erazor);
  if(irq==11) setvect(0x73,erazor);
}else setvect(8+irq,erazor);
// aktivieren des IRQs (alten Interrupt aktualisieren)
if(irq==2||irq==10||irq==11){
  if(irq==2)  outportb(0xA1,inportb(0xA1)&253);
  if(irq==10) outportb(0xA1,inportb(0xA1)&251);
  if(irq==11) outportb(0xA1,inportb(0xA1)&247);
  outportb(0x21,inportb(0x21)&251);
}else outportb(0x21,inportb(0x21)&!(1<<irq));
}
void init_sb(){
init_irq(); // neue Interrupt-Funktion einfgen
make_dma_buffer(); // DMA Buffer erzeugen
//clear_buff_nr=3; // letzte Pufferstelle lschen
clear_buff_nr=31;
}
void restore_irq(){
// alten Interrupt zuweisen
if(irq==2||irq==10||irq==11){
  if(irq==2)  setvect(0x71,old_irq);
  if(irq==10) setvect(0x72,old_irq);
  if(irq==11) setvect(0x73,old_irq);
}else setvect(8+irq,old_irq);
// aktivieren des IRQs
if(irq==2||irq==10||irq==11){
  if(irq==2)  outportb(0xA1,inportb(0xA1)&253);
  if(irq==10) outportb(0xA1,inportb(0xA1)&251);
  if(irq==11) outportb(0xA1,inportb(0xA1)&247);
  outportb(0x21,inportb(0x21)&251);
}else outportb(0x21,inportb(0x21)&!(1<<irq));
}
void close_sb(){
write_dsp(0xD0); // Auto-playback stoppen
write_dsp(0xDA);
free(dma_buffer_ptr); // DMA Puffer freigeben
restore_irq(); // alten Interrupt laden
}
void make_dma_buffer(){
unsigned char *temp_ptr;
long          adresse;
int           seg1,seg2;
temp_ptr=(char *)malloc(32768); // 32K Speicher reservieren
// absolute Adresse speichern seg*16+off (zB: 1000*16+ffff=1ffff)
adresse=FP_SEG(temp_ptr);
adresse=(adresse<<4)+FP_OFF(temp_ptr);
// Startsegment ermitteln (zB: 1ffff>>16=1)
seg1=adresse>>16;
// Endsegment ermitteln
seg2=(adresse+32767)>>16;
// Der Speicher darf sich nicht in 2 verschiedenen Segmenten befinden.
if(seg1!=seg2) {
  dma_buffer_ptr=(unsigned char *)malloc(32768); // Jetzt muss er ja in einem sein.
  free(temp_ptr); // alten Speicher lschen
}else dma_buffer_ptr=temp_ptr; // alles klar
memset(dma_buffer_ptr,128,0x7FFF); // Puffer leeren
}
void load_wave(struct wave_data *wave,char *name){
FILE *file;
file=fopen(name,"rb");
if(file==NULL){
  return;
}
// Die Lnge der Datei ermitteln (der Header ist 48 Bytes gro)
fseek(file,0L,SEEK_END);
if(ftell(file)-48-5>32768){
  wave->length=32768; // maximale Gre der Datei
}else{
  wave->length=ftell(file)-48-100-5;// -100 gegen das Knacken am Ende
}
wave->data=(unsigned char *)malloc(wave->length); // gengend Speicher zuweisen
fseek(file,48+5,SEEK_SET); // Dateizeiger hinter den Header setzen
// Die Daten in den Speicher laden
fread(wave->data,wave->length,1,file);
fclose(file); // Datei schlieen
}
void convert_wave(struct wave_data *wave){
unsigned int offset;
// Die Welle verkleinern um berlauffehler beim mixen zu vermeiden.
for(offset=0;offset<=wave->length;offset++){
  wave->data[offset]>>=2;
  wave->data[offset]-=32;
}
// Gegen das Knacken
wave->data[offset-1]=0;
}
void play(){
long         adresse;
unsigned int segment,offset;
write_dsp (0xD1); // Lautschprecher an
write_dsp (0x40); // Frequenz senden
write_dsp (165);  // konstante Frequenz von 11000Hz (256-1000000/Freqenz)
// lineare Adresse erzeugen
adresse=FP_SEG(dma_buffer_ptr);
adresse=(adresse<<4)+FP_OFF(dma_buffer_ptr);
segment=adresse>>16;
offset=adresse&0xFFFF;
outportb (0x0A,4|dma); // Ausgabekanal initialisieren
outportb(0x0C,0); // reset des DMA flip/flops
outportb(0x0B,0x58|dma); // Playback (45h Aufnahme)
outportb(dma<<1,offset&0xFF); // den low Anteil von buff_off senden
outportb(dma<<1,offset>>8); // den high Anteil von buff_off senden
// das Segment senden
if(dma==0)outportb(0x87,segment);
if(dma==1)outportb(0x83,segment);
if(dma==3)outportb(0x82,segment);
// Senden wieviel gespielt werden soll. (7FFF=32K)
outportb((dma<<1)+1,0xFF); // low
outportb((dma<<1)+1,0x7F); // high
outportb(0x0A,dma); // Ausgabekanal freigeben
// Dem DSP sagen wieviel er spielen soll. (1FFF=8K)
write_dsp(0x48);
write_dsp(0x00); // 0400=1K
write_dsp(0x04);
write_dsp (0x1C); // Auto-Playback
}
void mix_on_buff(unsigned char nr){
unsigned int i,offset,buff_pos;
// Anzahl der noch zu spielenden Daten ermitteln.
buff_pos=inportb(1+(dma<<1));
buff_pos=buff_pos+(inportb(1+(dma<<1))<<8);
// Stelle ermitteln, bei der der DMA-Zeiger gerade ist.
buff_pos=0x7FFF-buff_pos;
offset=buff_pos;
// Nun wird die die Wave von der aktuellen Position aus auf den Puffer gemixt.
for(i=0;i<=(waves[nr]).length;i++){
  // mixen
  dma_buffer_ptr[offset++]+=(waves[nr]).data[i];
  // Wenn die Wave ber das Ende des Puffers rausgeht,
  // am Anfang wieder anfangen.
  offset&=0x7FFF;
  }
}

//////////////////////////////////////////////////////////////////////////
// Maus		 							//
//////////////////////////////////////////////////////////////////////////
char ifmouse(){
unsigned int result;
asm{
  int 0x33
  mov result,ax
}
return result;
}
void readmouse(){
asm{
  mov ax, 0x3
  int 0x33
  mov mouseb,bx
  mov mousex,cx
  mov mousey,dx
}
}
void setmousexy(unsigned int x, unsigned int y){
asm{
  mov ax,0x4
  mov cx,x
  mov dx,y
  int 0x33
}
}
void setminmaxx(unsigned int min, unsigned int max){
asm{
  mov ax,0x7
  mov cx,min
  mov dx,max
  int 0x33
}
}
void setminmaxy(unsigned int min, unsigned int max){
asm{
  mov ax, 0x8
  mov cx, min
  mov dx, max
  int 0x33
}
}
void setspeed(unsigned int speedx, unsigned int speedy, unsigned int doublespeed){
asm{
  mov ax,0x1a
  mov bx,speedx
  mov cx,speedy
  mov dx,doublespeed
  int 0x33
}
}

//////////////////////////////////////////////////////////////////////////
// Tastatur	 							//
//////////////////////////////////////////////////////////////////////////
unsigned char q[100];
int qa=0,qe=0;
void interrupt int9(...){
unsigned char c=inportb(0x60);
q[qa]=c;qa++;qa%=100;
unsigned char a=inportb(0x61);
outportb(0x61,a|0x80);
outportb(0x61,a);
outportb(0x20,0x20);
}
void interrupt(far*oldint9)(...);
unsigned char getkey(void){
unsigned char ch;
if(qa!=qe){
  ch=q[qe];
  qe++;qe%=100;
  return ch;
}else{
  return 0;
}
}

//////////////////////////////////////////////////////////////////////////
// Men		 							//
//////////////////////////////////////////////////////////////////////////
int menue(unsigned char *cheat){
unsigned char status=255,taste=0,temp[81],i,first=1;
setmousexy(160,20);
setspeed(25,25,0);
setminmaxx(0,310);
setminmaxy(0,190);
memset(temp,0,81);
while(status==255){
  taste=getkey();
  if(!first){
    for(i=0;i<9;i++)
      if(i!=4)
	pixel_ptr[(mousey+i)*320+mousex+4]=temp[i*9+4];
    for(i=0;i<9;i++)
      if(i!=4)
	pixel_ptr[(mousey+4)*320+mousex+i]=temp[4*9+i];
  }else first=0;
  readmouse();
  if(taste==0x81)status=0;
  for(i=0;i<9;i++){
    if(i==4)continue;
    temp[i*9+4]=pixel_ptr[(mousey+i)*320+mousex+4];
    pixel_ptr[(mousey+i)*320+mousex+4]=206;
  }
  for(i=0;i<9;i++){
    if(i==4)continue;
    temp[4*9+i]=pixel_ptr[(mousey+4)*320+mousex+i];
    pixel_ptr[(mousey+4)*320+mousex+i]=206;
  }

  // NEU
  if(mousex>80&&mousex<240&&mousey>38&&mousey<62&&mouseb&0x1)
    status=1;
  // LADEN
  if(mousex>80&&mousex<240&&mousey>66&&mousey<84&&mouseb&0x1)
    status=2;
  // SPEICHERN
  if(mousex>76&&mousex<244&&mousey>92&&mousey<108&&mouseb&0x1)
    status=3;
  // WEITER
  if(mousex>123&&mousex<200&&mousey>114&&mousey<132&&mouseb&0x1)
    status=4;
  // EDITOR
  if(mousex>123&&mousex<200&&mousey>137&&mousey<155&&mouseb&0x1)
    status=5;
  // ENDE
  if(mousex>100&&mousex<220&&mousey>160&&mousey<178&&mouseb&0x1)
    status=0;
  // CHEAT
  if(mousex==302&&mousey==190&&mouseb&0x2)
    *cheat=1;

  retrace();
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
}
if(sound_on)mix_on_buff(8);
return status;
}

//////////////////////////////////////////////////////////////////////////
// Piloten	 							//
//////////////////////////////////////////////////////////////////////////
void make_ausgabe(unsigned char taste,unsigned char *pos,int x,unsigned char y,unsigned char len,unsigned char str[]){
int i;
unsigned char z_x=1,z_y;
switch(taste){
  case 0x90: z_x=24;z_y=10;break; //Q
  case 0x91: z_x=24;z_y=15;break; //W
  case 0x92: z_x=24;z_y=0;break; //E
  case 0x93: z_x=30;z_y=10;break; //R
  case 0x94: z_x=6;z_y=15;break; //T
  case 0x95: z_x=6;z_y=20;break; //Z
  case 0x96: z_x=12;z_y=15;break; //U
  case 0x97: z_x=12;z_y=5;break; //I
  case 0x98: z_x=12;z_y=10;break; //O
  case 0x99: z_x=18;z_y=10;break; //P
  case 0x9E: z_x=0;z_y=0;break; //A
  case 0x9F: z_x=0;z_y=15;break; //S
  case 0xA0: z_x=18;z_y=0;break; //D
  case 0xA1: z_x=30;z_y=0;break; //F
  case 0xA2: z_x=0;z_y=5;break; //G
  case 0xA3: z_x=6;z_y=5;break; //H
  case 0xA4: z_x=18;z_y=5;break; //J
  case 0xA5: z_x=24;z_y=5;break; //K
  case 0xA6: z_x=30;z_y=5;break; //L
  case 0xAC: z_x=0;z_y=20;break; //Y
  case 0xAD: z_x=30;z_y=15;break; //X
  case 0xAE: z_x=12;z_y=0;break; //C
  case 0xAF: z_x=18;z_y=15;break; //V
  case 0xB0: z_x=6;z_y=0;break; //B
  case 0xB1: z_x=6;z_y=10;break; //N
  case 0xB2: z_x=0;z_y=10;break; //M
  case 0x8B: z_x=0;z_y=25;break; //0
  case 0x82: z_x=6;z_y=25;break; //1
  case 0x83: z_x=12;z_y=25;break; //2
  case 0x84: z_x=18;z_y=25;break; //3
  case 0x85: z_x=24;z_y=25;break; //4
  case 0x86: z_x=30;z_y=25;break; //5
  case 0x87: z_x=0;z_y=30;break; //6
  case 0x88: z_x=6;z_y=30;break; //7
  case 0x89: z_x=12;z_y=30;break; //8
  case 0x8A: z_x=18;z_y=30;break; //9

}
if(taste==0xB9&&*pos<len){
  str[(*pos)]=32;
  str[(*pos)+1]=0;
  (*pos)++;
  if(sound_on)mix_on_buff(7);
}
if(taste==0x8E&&*pos>0){
  str[(*pos)-1]=0;
  (*pos)--;
  for(i=0;i<5;i++)
    memset(pixel_ptr+(y+i)*320+x+(*pos)*6,0,6);
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
  if(sound_on)mix_on_buff(11);
}
if(z_x!=1&&*pos<len){
  if(z_y<25){
    str[(*pos)]=(z_y/5)*6+z_x/6+65;
  }else{
    str[(*pos)]=(z_y/5-5)*6+z_x/6+48;
  }
  str[(*pos)+1]=0;
  for(i=0;i<5;i++){
    memcpy(pixel_ptr+(y+i)*320+x+(*pos)*6,be_ptr+(z_y+i)*36+z_x,6);
  }
  (*pos)++;
  if(sound_on)mix_on_buff(9);
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
}
}

int neuer_pilot(unsigned char cheat){
unsigned char taste=0,pos=0,str[17]={0};
while(taste!=0x81&&taste!=0x9c){
  taste=getkey();
  make_ausgabe(taste,&pos,142,93,16,str);
}
if(taste==0x81||str[0]==0)return 0;

if(sound_on)mix_on_buff(7);
strcpy(be.name,str);
if(strcmpi(be.name,"michael moench")==0&&cheat){
  be.reload_mg=7;
  be.reload_missel=40;
  be.missel=0;
  be.hits=250;
  be.max_hits=250;
  be.mg_d=3;
  be.missel_d=10;
  be.weapons=2;
  be.prozent=100;
  be.money=25000;
}else{
  be.reload_mg=10;
  be.reload_missel=50;
  be.missel=0;
  be.hits=100;
  be.max_hits=100;
  be.mg_d=1;
  be.missel_d=6;
  be.weapons=0;
  be.prozent=100;
  be.money=1000;
}

return 1;
}

int lade_pilot(){
unsigned char taste=0,pos=0,str[17]={0};
FILE *fp;
while(taste!=0x81&&taste!=0x9c){
  taste=getkey();
  make_ausgabe(taste,&pos,142,93,8,str);
}
if(taste==0x81||str[0]==0)return 0;
strcat(str,".pil");
if((fp=fopen(str,"rb"))==NULL)return 0;
fread(&be,sizeof(be),1,fp);
fclose(fp);
return 1;
}
void save_pilot(){
unsigned char taste=0,pos=0,str[17]={0};
FILE *fp;
while(taste!=0x81&&taste!=0x9c){
  taste=getkey();
  make_ausgabe(taste,&pos,142,93,8,str);
}
if(taste==0x81||str[0]==0)return;
strcat(str,".pil");
fp=fopen(str,"w+b");
fwrite(&be,sizeof(be),1,fp);
fclose(fp);
}

int load_mission(){
unsigned char taste=0,pos=0,str[17]={0};
FILE *fp;
while(taste!=0x81&&taste!=0x9c){
  taste=getkey();
  make_ausgabe(taste,&pos,120,80,8,str);
}
if(taste==0x81||str[0]==0)return 0;
strcat(str,".mis");
if((fp=fopen(str,"rb"))==NULL)return 0;
fread(boden,sizeof(boden),1,fp);
fread(&enemys,sizeof(enemys),1,fp);
fread(&haus,sizeof(haus),1,fp);
fclose(fp);
return 1;
}

//////////////////////////////////////////////////////////////////////////
// Hangar	 							//
//////////////////////////////////////////////////////////////////////////
int the_hangar(){
unsigned char status=255,taste=0,temp[81],i,first=1;
setmousexy(160,20);
setspeed(25,25,0);
setminmaxx(0,310);
setminmaxy(0,190);
memset(temp,0,81);
while(status==255){
  taste=getkey();
  if(!first){
    for(i=0;i<9;i++)
      if(i!=4)
	pixel_ptr[(mousey+i)*320+mousex+4]=temp[i*9+4];
    for(i=0;i<9;i++)
      if(i!=4)
	pixel_ptr[(mousey+4)*320+mousex+i]=temp[4*9+i];
  }else first=0;
  readmouse();
  if(taste==0x81||(mousey>=180&&mouseb&0x1)){
    status=0;
    if(sound_on)mix_on_buff(0);
  }

  if(mousey>=102&&mousey<=160&&mousex>=48&&mousex<=144&&mouseb&0x1){
    if(sound_on)mix_on_buff(7);
    status=2;
  }

  if(mousey>=52&&mousey<=102&&mousex>=92&&mousex<=212&&mouseb&0x1){
    if(sound_on)mix_on_buff(5);
    status=1;
  }

  for(i=0;i<9;i++){
    if(i==4)continue;
    temp[i*9+4]=pixel_ptr[(mousey+i)*320+mousex+4];
    pixel_ptr[(mousey+i)*320+mousex+4]=228;
  }
  for(i=0;i<9;i++){
    if(i==4)continue;
    temp[4*9+i]=pixel_ptr[(mousey+4)*320+mousex+i];
    pixel_ptr[(mousey+4)*320+mousex+i]=228;
  }
  retrace();
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
}
return status;
}

//////////////////////////////////////////////////////////////////////////
// Ausrstung	 							//
//////////////////////////////////////////////////////////////////////////
void ausruestung(){
unsigned char status=0,taste=0,temp[81],i,first=1;
setmousexy(160,20);
setspeed(25,25,0);
setminmaxx(0,310);
setminmaxy(0,190);
memset(temp,0,81);
while(status!=255){
  taste=getkey();
  if(!first){
    for(i=0;i<9;i++)
      if(i!=4)
	pixel_ptr[(mousey+i)*320+mousex+4]=temp[i*9+4];
    for(i=0;i<9;i++)
      if(i!=4)
	pixel_ptr[(mousey+4)*320+mousex+i]=temp[4*9+i];
  }else first=0;
  readmouse();
  if(taste==0x81||(mousex>=128&&mousex<=178&&mousey>=4&&mousey<=20&&mouseb&0x1)){
    if(sound_on)mix_on_buff(11);
    status=255;
  }
  if(mousex>=74&&mousex<=124&&mousey>=4&&mousey<=20&&mouseb&0x1)
    status=1;
  if(mousex>=20&&mousex<=70&&mousey>=4&&mousey<=20&&mouseb&0x1)
    status=2;

//////////////
  if(status==1){
    pcx("ausr.res",pixel_ptr,320,200);
    for(i=0;i<8;i++)
      memset(pixel_ptr+(140+i)*320+32,0,60);
    if(be.money<1000||be.reload_mg==7){
      for(i=0;i<16;i++)memset(pixel_ptr+(33+i)*320+163,13,50);}
    if(be.money<1000||be.reload_missel==40){
      for(i=0;i<16;i++)memset(pixel_ptr+(52+i)*320+163,13,50);}
    if(be.money<1000||be.mg_d==3){
      for(i=0;i<16;i++)memset(pixel_ptr+(71+i)*320+163,13,50);}
    if(be.money<1000||be.missel_d==10){
      for(i=0;i<16;i++)memset(pixel_ptr+(90+i)*320+163,13,50);}
    if(be.money<1000||be.max_hits==250){
      for(i=0;i<16;i++)memset(pixel_ptr+(109+i)*320+163,13,50);}
    status=10;
  }
  if(status==10){
    if(mousex>=158&&mousex<=208&&mousey>=28&&mousey<=44&&mouseb&0x1)
      if(be.money>=1000&&be.reload_mg>7){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.reload_mg--;
	be.money-=1000;
	status=1;
      }else{
	if(sound_on)mix_on_buff(2);
      }
    if(mousex>=158&&mousex<=208&&mousey>=47&&mousey<=63&&mouseb&0x1)
      if(be.money>=1000&&be.reload_missel>40){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.reload_missel-=5;
	be.money-=1000;
	status=1;
      }else{
	if(sound_on)mix_on_buff(2);
      }
    if(mousex>=158&&mousex<=208&&mousey>=66&&mousey<=82&&mouseb&0x1)
      if(be.money>=1000&&be.mg_d<3){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.mg_d++;
	be.money-=1000;
	status=1;
      }else{
	if(sound_on)mix_on_buff(2);
      }
    if(mousex>=158&&mousex<=208&&mousey>=85&&mousey<=101&&mouseb&0x1)
      if(be.money>=1000&&be.missel_d<10){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.missel_d+=2;
	be.money-=1000;
	status=1;
      }else{
	if(sound_on)mix_on_buff(2);
      }
    if(mousex>=158&&mousex<=208&&mousey>=104&&mousey<=120&&mouseb&0x1)
      if(be.money>=1000&&be.max_hits<250){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.max_hits+=50;
	be.money-=1000;
	status=1;
      }else{
	if(sound_on)mix_on_buff(2);
      }
  }

  if(status==2){
    pcx("ausr1.res",pixel_ptr,320,200);
    if(be.money<1000||be.hits==be.max_hits){
      for(i=0;i<16;i++)memset(pixel_ptr+(168+i)*320+33,13,50);}
    if(be.money<15000||be.weapons!=0){
      for(i=0;i<16;i++)memset(pixel_ptr+(168+i)*320+132,13,50);}
    if(be.money<20000||be.weapons!=1){
      for(i=0;i<16;i++)memset(pixel_ptr+(168+i)*320+235,13,50);}

    status=20;
  }

  if(status==20){
    for(i=0;i<8;i++){
      memcpy(pixel_ptr+(157+i)*320+55,be_ptr+i*60+(be.prozent%10)*6,6);
      memcpy(pixel_ptr+(157+i)*320+55-6,be_ptr+i*60+(be.prozent/10%10)*6,6);
      memcpy(pixel_ptr+(157+i)*320+55-12,be_ptr+i*60+(be.prozent/100%10)*6,6);
    }

    if(mousex>=28&&mousex<=78&&mousey>=163&&mousey<=179&&mouseb&0x1)
      if(be.money>=1000&&be.hits<be.max_hits){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.hits+=25;
	be.money-=1000;
	if(be.hits>be.max_hits)be.hits=be.max_hits;
	be.prozent=(be.hits*100)/be.max_hits;
	status=2;
      }else{
	if(sound_on)mix_on_buff(2);
      }

    if(mousex>=127&&mousex<=177&&mousey>=163&&mousey<=179&&mouseb&0x1)
      if(be.money>=15000&&be.weapons==0){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.weapons=1;
	be.money-=15000;
	status=2;
      }else{
	if(sound_on)mix_on_buff(2);
      }

    if(mousex>=230&&mousex<=280&&mousey>=163&&mousey<=179&&mouseb&0x1)
      if(be.money>=20000&&be.weapons==1){
	if(sound_on)mix_on_buff(1);
	delay(500);
	be.weapons=2;
	be.money-=20000;
	status=2;
      }else{
	if(sound_on)mix_on_buff(2);
      }

  }
//////////////


  for(i=0;i<8;i++){
    memcpy(pixel_ptr+(14+i)*320+288,be_ptr+i*60+(be.money%10)*6,6);
    memcpy(pixel_ptr+(14+i)*320+288-6,be_ptr+i*60+(be.money/10%10)*6,6);
    memcpy(pixel_ptr+(14+i)*320+288-12,be_ptr+i*60+(be.money/100%10)*6,6);
    memcpy(pixel_ptr+(14+i)*320+288-18,be_ptr+i*60+(be.money/1000%10)*6,6);
    memcpy(pixel_ptr+(14+i)*320+288-24,be_ptr+i*60+(be.money/10000%10)*6,6);
  }

  for(i=0;i<9;i++){
    if(i==4)continue;
    temp[i*9+4]=pixel_ptr[(mousey+i)*320+mousex+4];
    pixel_ptr[(mousey+i)*320+mousex+4]=250;
  }
  for(i=0;i<9;i++){
    if(i==4)continue;
    temp[4*9+i]=pixel_ptr[(mousey+4)*320+mousex+i];
    pixel_ptr[(mousey+4)*320+mousex+i]=250;
  }
  retrace();
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
}
}

//////////////////////////////////////////////////////////////////////////
// EDITOR	 							//
//////////////////////////////////////////////////////////////////////////
void make_enemys_editor(){
unsigned char i,x,y;
int ry,yy;
for(i=0;i<50;i++){
  if(enemys[i].typ==255)continue;
  yy=-enemys[i].y+world_y+200-64;
  ry=yy;
  if(yy<250){
    if(!enemys[i].viewable){
      enemys[i].viewable=1;
    }else{
      switch(enemys[i].typ){
	case 0:y=22;break;
	case 1:y=31;break;
	case 2:y=25;break;
	case 3:y=32;break;
	case 4:y=26;break;
	case 5:y=28;break;
	case 6:y=21;break;
      }
      if(yy<-20){enemys[i].viewable=0;continue;}
      ///////////
      // TYP 0 //
      ///////////
      if(enemys[i].typ==0){
	// PAINT
	for(y=0;y<22;y++){
	  ry++;
	  for(x=0;x<22;x++){
	    if(enemy_ptr[y*186+x]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x];
	  }
	}
	continue;
      }
      ///////////
      // TYP 1 //
      ///////////
      if(enemys[i].typ==1){
	// PAINT
	for(y=0;y<29;y++){
	  ry++;
	  for(x=0;x<30;x++){
	    if(enemy_ptr[y*186+x+22]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+22];
	  }
	}
	continue;
      }
      ///////////
      // TYP 2 //
      ///////////
      if(enemys[i].typ==2){
	// PAINT
	for(y=0;y<24;y++){
	  ry++;
	  for(x=0;x<25;x++){
	    if(enemy_ptr[y*186+x+53]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+53];
	  }
	}
	continue;
      }
      ///////////
      // TYP 3 //
      ///////////
      if(enemys[i].typ==3){
	// PAINT
	for(y=0;y<20;y++){
	  ry++;
	  for(x=0;x<32;x++){
	    if(enemy_ptr[y*186+x+78]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+78];
	  }
	}
	continue;
      }
      ///////////
      // TYP 4 //
      ///////////
      if(enemys[i].typ==4){
	// PAINT
	for(y=0;y<30;y++){
	  ry++;
	  for(x=0;x<26;x++){
	    if(enemy_ptr[y*186+x+110]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+110];
	  }
	}
	continue;
      }
      ///////////
      // TYP 5 //
      ///////////
      if(enemys[i].typ==5){
	// PAINT
	for(y=0;y<32;y++){
	  ry++;
	  for(x=0;x<28;x++){
	    if(enemy_ptr[y*186+x+136]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+136];
	  }
	}
	continue;
      }
      ///////////
      // TYP 6 //
      ///////////
      if(enemys[i].typ==6){
	// PAINT
	for(y=0;y<22;y++){
	  ry++;
	  for(x=0;x<22;x++){
	    if(enemy_ptr[y*186+x+164]!=255&&ry>=0&&ry<200)
	      pixel_ptr[ry*320+enemys[i].x+x]=enemy_ptr[y*186+x+164];
	  }
	}
	continue;
      }

    }
  }
}
}

void make_haus_editor(){
unsigned char i,k;
int y;
for(i=0;i<50;i++){
  if(haus[i].typ==255)continue;
  y=-haus[i].y+world_y+200;
  if(y>=-32&&!haus[i].viewable)haus[i].viewable=1;
  if(!haus[i].viewable)continue;
  for(k=0;k<32;k++){
    if(y<200&&y>=0){
      if(haus[i].viewable==1){
	memcpy(MK_FP(pixel_ptr,(y)*320+haus[i].x+4),MK_FP(haus_ptr,k*320+4+haus[i].typ*32),32U);
      }else{
	memcpy(MK_FP(pixel_ptr,(y)*320+haus[i].x+4),MK_FP(haus_ptr,(k+32*(anni_nr+1))*320+4+haus[i].typ*32),32U);
      }
    }
    y++;
  }

  if(world_y+200-haus[i].y>199){haus[i].viewable=0;}
}
}

void der_editor(){
char pos_x=0,pos_y=6;
unsigned char taste=0,gew_boden=0,old_boden,space=0,mode='k';
unsigned int i;
unsigned char pos=0,str[17]={0};
int temp;
FILE *fp;

for(i=0;i<50;i++){
  haus[i].viewable=0;
  haus[i].typ=255;
  }
for(i=0;i<50;i++){
  enemys[i].typ=255;
  enemys[i].viewable=0;
}
// Enemys
enemy_ptr=(unsigned char *)malloc(9672);
pcx("enemy.res",enemy_ptr,186,52);
// Haus
haus_ptr=(unsigned char *)malloc(40960);
pcx("haus.res",haus_ptr,320,128);
// Wasser
water_ptr=(unsigned char *)malloc(3072+637);//3072
pcx("water.res",water_ptr,96,32);
// Felsen
fels_ptr=(unsigned char *)malloc(28672);
pcx("fels.res",fels_ptr,896,32);
// Gras
gras_ptr=(unsigned char *)malloc(28672);
pcx("gras.res",gras_ptr,896,32);
// beton
beton_ptr=(unsigned char *)malloc(15360);
pcx("beton.res",beton_ptr,480,32);

pcx("info.res",pixel_ptr,320,200);
pal("game_pal.rep");
_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
while(taste!=0xB9)taste=getkey();

for(i=0;i<3000;i++)
  boden[i]=random(2);
world_y=0;
frames=0;

while(taste!=0x81){
  taste=getkey();

  space=0;
  if(taste==0xB9)space=1;
  if(taste==0xA5)mode='k';
  if(taste==0x92)mode='e';
  if(taste==0xA3)mode='h';

  if(taste==0xBB){
    pcx("info.res",pixel_ptr,320,200);
    _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
    while(taste!=0xB9)taste=getkey();
  }
  if(taste==0xBC){ //save
    for(i=0;i<50;i++)
      haus[i].viewable=0;
    for(i=0;i<50;i++)
      enemys[i].viewable=0;
    space=0;
    pos=0;
    while(space!=0x9C){
      space=getkey();
      make_ausgabe(space,&pos,0,0,8,str);
      _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
    }
    strcat(str,".mis");
    fp=fopen(str,"w+b");
    fwrite(boden,sizeof(boden),1,fp);
    fwrite(&enemys,sizeof(enemys),1,fp);
    fwrite(&haus,sizeof(haus),1,fp);
    fclose(fp);
    space=0;
  }
  if(taste==0xBD){ //load
    space=0;
    pos=0;
    while(space!=0x9C){
      space=getkey();
      make_ausgabe(space,&pos,0,0,8,str);
      _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
    }
    strcat(str,".mis");
    fp=fopen(str,"rb");
    if(fp!=NULL){
      fread(boden,sizeof(boden),1,fp);
      fread(&enemys,sizeof(enemys),1,fp);
      fread(&haus,sizeof(haus),1,fp);
      fclose(fp);
    }
    space=0;
  }

  if(mode=='e'){
    space=0;
    while(space==0){
      taste=getkey();
      if(taste==0x82)space=1;
      if(taste==0x83)space=2;
      if(taste==0x84)space=3;
      if(taste==0x85)space=4;
      if(taste==0x86)space=5;
      if(taste==0x87)space=6;
      if(taste==0x88)space=7;
      if(taste==0xD3)space=255;
      for(i=0;i<52;i++)
	memcpy(pixel_ptr+(i+8)*320,enemy_ptr+i*186,186);
      _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
    }
    if(space!=255){
      for(i=0;i<50;i++){
	if(enemys[i].typ!=255)continue;
      enemys[i].typ=space-1;
      enemys[i].x=pos_x*32;
      enemys[i].y=(5-pos_y)*32+world_y;

      if(space==1)enemys[i].hits=10;
      if(space==2)enemys[i].hits=15;
      if(space==3)enemys[i].hits=10;
      if(space==4)enemys[i].hits=20;
      if(space==5)enemys[i].hits=20;
      if(space==6)enemys[i].hits=25;
      if(space==7)enemys[i].hits=25;

      space=0;
      pos=0;
      while(space!=0x9C){
	space=getkey();
	make_ausgabe(space,&pos,0,0,3,str);
	_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
      }
      space=0;
      if(str[0]=='N'){space=1;str[0]=str[1];str[1]=str[2];str[3]=0;}
      temp=0;
      sscanf(str,"%d",&temp);
      if(space)temp*=-1;

      enemys[i].fx=temp;

      space=0;
      pos=0;
      while(space!=0x9C){
	space=getkey();
	make_ausgabe(space,&pos,50,0,2,str);
	_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
      }
      temp=1;
      sscanf(str,"%d",&temp);
      if(temp==0)temp=1;

      enemys[i].fy=temp;
      if(enemys[i].fy==1&&enemys[i].fx==0)enemys[i].fy=2;
      break;
    }
    }else{
      for(i=0;i<50;i++){
	enemys[i].typ=255;
	enemys[i].viewable=0;
      }
    }
    mode='k';
    space=0;
  }

  if(mode=='h'){
    space=0;
    while(space==0){
      taste=getkey();
      if(taste==0x82)space=1;
      if(taste==0x83)space=2;
      if(taste==0x84)space=3;
      if(taste==0x85)space=4;
      if(taste==0x86)space=5;
      if(taste==0x87)space=6;
      if(taste==0x88)space=7;
      if(taste==0x89)space=8;
      if(taste==0x8A)space=9;
      if(taste==0x8B)space=10;
      if(taste==0xD3)space=255;
      for(i=0;i<32;i++)
	memcpy(pixel_ptr+(i+8)*320,haus_ptr+i*320,320);
      _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
    }
    if(space!=255){
      for(i=0;i<50;i++){
	if(haus[i].typ!=255)continue;
      haus[i].typ=space-1;
      haus[i].x=pos_x*32;
      haus[i].y=(5-pos_y)*32+64+world_y;
      if(space-1==0||space-1==1)haus[i].hits=10;
      if(space-1==2||space-1==3)haus[i].hits=30;
      if(space-1==4||space-1==5)haus[i].hits=40;
      if(space-1==6)haus[i].hits=45;
      if(space-1==7||space-1==8||space-1==9)haus[i].hits=15;

      break;
    }
    }else{
      for(i=0;i<50;i++){
	haus[i].viewable=0;
	haus[i].typ=255;
      }
    }
    mode='k';
    space=0;
  }

  if(mode=='k'){
    if(taste==0x48)if(pos_y>1){pos_y--;}else{if(world_y<3000)world_y+=32;}
    if(taste==0x50)if(pos_y<6){pos_y++;}else{if(world_y>0)world_y-=32;}
    if(taste==0x4B&&pos_x>0)pos_x--;
    if(taste==0x4D&&pos_x<9)pos_x++;
    if(taste==0x1B){if(gew_boden==72)gew_boden=0;else gew_boden++;}
    if(taste==0x35){if(gew_boden==0)gew_boden=72;else gew_boden--;}

    old_boden=boden[(6-pos_y)*10+(world_y/32)*10+pos_x];
    boden[(6-pos_y)*10+(world_y/32)*10+pos_x]=gew_boden;

    make_boden();
    make_haus_editor();
    make_enemys_editor();

    if(!space)boden[(6-pos_y)*10+(world_y/32)*10+pos_x]=old_boden;

    if(old_boden==gew_boden){
      memset(pixel_ptr+(pos_y*32+8-32)*320+pos_x*32,230,32);
      memset(pixel_ptr+(pos_y*32+8-1)*320+pos_x*32,230,32);
    }else{
      memset(pixel_ptr+(pos_y*32+8-32)*320+pos_x*32,240,32);
      memset(pixel_ptr+(pos_y*32+8-1)*320+pos_x*32,240,32);
    }
  }

  memset(pixel_ptr,0,2560);

  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
}

free(water_ptr);
free(fels_ptr);
free(enemy_ptr);
free(haus_ptr);
free(gras_ptr);
free(beton_ptr);
}

//////////////////////////////////////////////////////////////////////////
// Main		 							//
//////////////////////////////////////////////////////////////////////////
int main(int argc,unsigned char *argv[]){
unsigned long i;
unsigned char key=0,j,k,cheat=0,running_game=0;
FILE *fp;
// sauber machen
asm mov ax,0x3
asm int 0x10
// Zeiger zuweisen
text_ptr=(unsigned char *)MK_FP(0xb800,0);

for(i=0;i<80*3;i++){
  *(text_ptr+i*2)=0x0;
  *(text_ptr+i*2+1)=0x40;
  }
textcolor(2);
gotoxy(23,2);
printf("*** MICHAEL MNCHS BLACK EAGLE ***");
gotoxy(1,4);

i=strlen(argv[0]);
if(i>=8&&
   argv[0][i-1]=='E'&&
   argv[0][i-2]=='X'&&
   argv[0][i-3]=='E'&&
   argv[0][i-4]=='.'&&
   argv[0][i-5]=='E'&&
   argv[0][i-6]=='B'&&
   argv[0][i-7]=='M'&&
   argv[0][i-8]=='M'){}else{
  printf("\nDiese Datei muss den Name MMBE.EXE haben !!!\n\n");
  return 1;
}

printf("Lade Programm...");
delay(250);
gotoxy(30,wherey());cprintf("OK");
printf("\nSuche Maus...");
delay(250);
if(!ifmouse()){
  gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
  printf("\nEs wurde keine Maus gefunden.\n\n");
  return 1;
}else{
  gotoxy(30,wherey());cprintf("OK");
}

printf("\nSuche SoundBlaster...");
delay(250);
if(!find_sb()){
  sound_on=0;
  gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");textcolor(2);
}else{
  sound_on=1;
  gotoxy(30,wherey());cprintf("OK");
}

nochmal:
i=need_mem_sound;
if(!sound_on)i=need_mem_no_sound;
printf("\nberprfe freien Speicher...");
delay(250);
if(coreleft()<i){
  gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
  printf("\nEs werden %lu Bytes Speicher bentigt.\nEs sind aber nur %lu Bytes verfgbar.",i,coreleft());
  if(sound_on){
    printf("\nSoll der Sound ausgeschaltet werden (j/n)? ");
    while(key!='j'&&key!='n'){
      if(kbhit()){key=getch();}else{key=0;}
    }
    printf("%c",key);
    if(key=='j'){sound_on=0;textcolor(2);goto nochmal;}
  }
  printf("\n\n");
  return 1;
}else{
  gotoxy(30,wherey());cprintf("OK");
}

printf("\nErstelle Index...");
delay(250);
if((fp=fopen("ausr.rep","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <ausr.rep> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("ausr.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <ausr.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("ausr1.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <ausr1.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("b_eagle.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <b_eagle.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("back.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <back.re> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("beton.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <beton.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("buy.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <buy.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("enemy.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <enemy.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("exp.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <exp.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("f_bang.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <f_bang.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("fels.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <fels.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("fly.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <fly.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("game_pal.rep","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <game_pal.rep> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("gras.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <gras.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("h_bang.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <h_bang.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("hangar.rep","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <hangar.rep> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("hangar.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <hangar.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("haus.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <haus.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("hud.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <hud.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("in.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <in.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("info.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <info.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("load.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <load.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("menu.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <menu.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("menue.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <menue.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("menue.rep","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <menue.rep> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("mg.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <mg.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("missel.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <missel.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("name.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <name.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("not_buy.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <not_buy.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("plasma.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <plasma.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("titel.rep","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <titel.rep> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("titel.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <titel.res> fehlt !!!\n\n");return 1;}fclose(fp);
if((fp=fopen("water.res","r"))==NULL){gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
printf("\nDie Datei <water.res> fehlt !!!\n\n");return 1;}fclose(fp);

gotoxy(30,wherey());cprintf("OK");

if(sound_on){
  printf("\nSound initialisieren...");
  delay(250);
  init_sb();
  play();
  gotoxy(30,wherey());cprintf("OK");
  printf("\nSounds laden...");
  load_wave(&waves[0],"back.res");
  load_wave(&waves[1],"buy.res");
  load_wave(&waves[2],"not_buy.res");
  load_wave(&waves[3],"f_bang.res");
  load_wave(&waves[4],"plasma.res");
  load_wave(&waves[5],"fly.res");
  load_wave(&waves[6],"h_bang.res");
  load_wave(&waves[7],"in.res");
  load_wave(&waves[8],"menu.res");
  load_wave(&waves[9],"mg.res");
  load_wave(&waves[10],"missel.res");
  load_wave(&waves[11],"next.res");
  convert_wave(&waves[0]);
  convert_wave(&waves[1]);
  convert_wave(&waves[2]);
  convert_wave(&waves[3]);
  convert_wave(&waves[4]);
  convert_wave(&waves[5]);
  convert_wave(&waves[6]);
  convert_wave(&waves[7]);
  convert_wave(&waves[8]);
  convert_wave(&waves[9]);
  convert_wave(&waves[10]);
  convert_wave(&waves[11]);

  gotoxy(30,wherey());cprintf("OK");
}

printf("\nErstelle VGA-Puffer...");
delay(250);
pixel_ptr=(unsigned char *)malloc(64000);
if(pixel_ptr!=NULL){
  gotoxy(30,wherey());cprintf("OK");
}else{
  gotoxy(30,wherey());textcolor(4);cprintf("FEHLER");
  return 1;
}

printf("\nLade Grafiken...");
delay(250);
gotoxy(30,wherey());cprintf("OK");

oldint9=getvect(9);
setvect(9,int9);

asm mov ax,0x13
asm int 0x10

fade_pal("titel.rep",1);
pcx("titel.res",pixel_ptr,320,200);
_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
if(sound_on)mix_on_buff(5);
fade_pal("titel.rep",0);
delay(3000);
fade_pal("titel.rep",1);
menue_again:
pcx("menue.res",pixel_ptr,320,200);

be_ptr=(unsigned char *)malloc(1260);
for(i=0;i<35;i++){
    memcpy(be_ptr+i*36,pixel_ptr+(i+110)*320,36);
    memset(pixel_ptr+(i+110)*320,0,36);
  }
_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
fade_pal("menue.rep",0);
k=menue(&cheat);
if(k==0){
  fade_pal("menue.rep",1);
  free(be_ptr);
  goto go_exit;
}
if(k==4){
  if(!running_game)goto menue_again;
  fade_pal("menue.rep",1);
  free(be_ptr);
  goto der_hangar;
}
if(k==5){
  fade_pal("menue.rep",1);
  der_editor();
  free(be_ptr);
  goto menue_again;
}
if(k==2){
  be_missel_ptr=(unsigned char *)malloc(10000);
  pcx("name.res",be_missel_ptr,200,50);
  for(i=0;i<50;i++)
    memcpy(pixel_ptr+(i+70)*320+60,be_missel_ptr+i*200,200);
  free(be_missel_ptr);
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
  if(!lade_pilot()){
    free(be_ptr);
    goto menue_again;
  }
}
if(k==3){
  be_missel_ptr=(unsigned char *)malloc(10000);
  pcx("name.res",be_missel_ptr,200,50);
  for(i=0;i<50;i++)
    memcpy(pixel_ptr+(i+70)*320+60,be_missel_ptr+i*200,200);
  free(be_missel_ptr);
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
  save_pilot();
  free(be_ptr);
  goto menue_again;
}
if(k==1){
  be_missel_ptr=(unsigned char *)malloc(10000);
  pcx("name.res",be_missel_ptr,200,50);
  for(i=0;i<50;i++)
    memcpy(pixel_ptr+(i+70)*320+60,be_missel_ptr+i*200,200);
  free(be_missel_ptr);
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
  if(!neuer_pilot(cheat)){
    free(be_ptr);
    goto menue_again;
  }
}
free(be_ptr);
fade_pal("menue.rep",1);


der_hangar:
running_game=1;
pcx("hangar.res",pixel_ptr,320,200);

_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
fade_pal("hangar.rep",0);
i=the_hangar();
fade_pal("hangar.rep",1);
if(i==0)goto menue_again;
if(i==1){
  pcx("menue.res",pixel_ptr,320,200);
  be_ptr=(unsigned char *)malloc(1260);
  for(i=0;i<35;i++){
    memcpy(be_ptr+i*36,pixel_ptr+(i+110)*320,36);
    memset(pixel_ptr+(i+110)*320,0,36);
  }
  pal("menue.rep");
  pcx("load.res",pixel_ptr,320,200);
  _fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
  if(load_mission()==0){
    free(be_ptr);
    goto der_hangar;
  }
  free(be_ptr);
  goto zum_spiel;
}

pcx("ausr.res",pixel_ptr,320,200);
be_ptr=(unsigned char *)malloc(480);
for(i=0;i<8;i++)
  memcpy(be_ptr+i*60,pixel_ptr+(140+i)*320+32,60);
for(i=0;i<158;i++)
  memset(pixel_ptr+(30+i)*320+11,0,296);
_fmemcpy(MK_FP(0xa000,0),pixel_ptr,64000U);
fade_pal("ausr.rep",0);
ausruestung();
free(be_ptr);
fade_pal("ausr.rep",1);
goto der_hangar;

zum_spiel:
// Black Eagle
be_ptr=(unsigned char *)malloc(5916);
pcx("b_eagle.res",be_ptr,116,51);
be_missel_ptr=(unsigned char *)malloc(40);
for(j=0;j<10;j++)
  for(k=0;k<4;k++)
    be_missel_ptr[j*4+k]=be_ptr[(j+30)*116+k+27];
be_missel2_ptr=(unsigned char *)malloc(40);
for(j=0;j<10;j++)
  for(k=0;k<4;k++)
    be_missel2_ptr[j*4+k]=be_ptr[(j+30)*116+k+35];
enemy_missel_ptr=(unsigned char *)malloc(40);
for(j=0;j<10;j++)
  for(k=0;k<4;k++)
    enemy_missel_ptr[j*4+k]=be_ptr[(j+30)*116+k+31];
plasma_ptr=(unsigned char *)malloc(36);
for(j=0;j<6;j++)
  for(k=0;k<6;k++)
    plasma_ptr[j*6+k]=be_ptr[(j+30)*116+k+21];
// Enemys
enemy_ptr=(unsigned char *)malloc(9672);
pcx("enemy.res",enemy_ptr,186,52);
// Haus
haus_ptr=(unsigned char *)malloc(40960);
pcx("haus.res",haus_ptr,320,128);
// Explosionen
exp_ptr=(unsigned char *)malloc(28672);
pcx("exp.res",exp_ptr,224,128);
// Wasser
water_ptr=(unsigned char *)malloc(3072+637);//3072
pcx("water.res",water_ptr,96,32);
// Felsen
fels_ptr=(unsigned char *)malloc(28672);
pcx("fels.res",fels_ptr,896,32);
// Gras
gras_ptr=(unsigned char *)malloc(28672);
pcx("gras.res",gras_ptr,896,32);
// beton
beton_ptr=(unsigned char *)malloc(15360);
pcx("beton.res",beton_ptr,480,32);
// Hud
hud_ptr=(unsigned char *)malloc(1792);
pcx("hud.res",hud_ptr,112,16);
pal("GAME_PAL.rep");

if(game()){
  free(be_ptr);
  free(be_missel_ptr);
  free(be_missel2_ptr);
  free(plasma_ptr);
  free(enemy_missel_ptr);
  free(water_ptr);
  free(fels_ptr);
  free(enemy_ptr);
  free(exp_ptr);
  free(haus_ptr);
  free(gras_ptr);
  free(beton_ptr);
  free(hud_ptr);

  goto go_exit;
}
free(be_ptr);
free(be_missel_ptr);
free(be_missel2_ptr);
free(plasma_ptr);
free(enemy_missel_ptr);
free(water_ptr);
free(fels_ptr);
free(enemy_ptr);
free(exp_ptr);
free(haus_ptr);
free(gras_ptr);
free(beton_ptr);
free(hud_ptr);

// Zurck zum Hangar
goto der_hangar;

// ENDE
go_exit:

if(sound_on){
  close_sb();
  free((&waves[0])->data);
  free((&waves[1])->data);
  free((&waves[2])->data);
  free((&waves[3])->data);
  free((&waves[4])->data);
  free((&waves[5])->data);
  free((&waves[6])->data);
  free((&waves[7])->data);
  free((&waves[8])->data);
  free((&waves[9])->data);
  free((&waves[10])->data);
  free((&waves[11])->data);
}

free(pixel_ptr);
setvect(9,oldint9);
asm mov ax,0x3
asm int 0x10
printf("made by michael mnch\n");
return 0;
}